diff --git a/luci/Makefile b/luci/Makefile
index 9fbc587..b1d250d 100644
--- a/luci/Makefile
+++ b/luci/Makefile
@@ -1,6 +1,6 @@
 include $(TOPDIR)/rules.mk
 
-PKG_BRANCH:=branches/luci-0.11
+PKG_BRANCH:=tags/0.11.1
 
 ifeq ($(DUMP),)
   USELOCAL:=$(shell grep luci ../../../.project 2>/dev/null >/dev/null && echo 1)
@@ -16,8 +16,8 @@ ifeq ($(USELOCAL),1)
 else
   PKG_SOURCE_URL:=http://svn.luci.subsignal.org/luci/$(PKG_BRANCH)
   ifeq ($(DUMP),)
-    PKG_REV:=$(shell LC_ALL=C svn info $(CURDIR) | sed -ne's/^Revision: //p')
-    PKG_VERSION:=0.11+svn$(PKG_REV)
+    PKG_REV:=HEAD
+    PKG_VERSION:=0.11.1
   endif
   PKG_SOURCE_SUBDIR:=$(PKG_NAME)-$(PKG_VERSION)
   PKG_SOURCE:=$(PKG_SOURCE_SUBDIR).tar.gz
@@ -29,6 +29,8 @@ PKG_BUILD_DEPENDS:=$(if $(STAGING_DIR_ROOT),lua/host)
 PKG_BUILD_DIR:=$(BUILD_DIR)/$(PKG_NAME)-$(PKG_VERSION)
 PKG_INSTALL_DIR:=$(PKG_BUILD_DIR)/ipkg-install
 
+PKG_MIRROR_MD5SUM:=d65ab9a2e53692e46a80df55aa08ac2d
+
 LUA_TARGET:=source
 LUCI_CFLAGS:=
 LUCI_BUILD_PACKAGES:=
diff --git a/luci/patches/001-add-80211n-11ac-advance-configuration.patch b/luci/patches/001-add-80211n-11ac-advance-configuration.patch
new file mode 100644
index 0000000..3f0a059
--- /dev/null
+++ b/luci/patches/001-add-80211n-11ac-advance-configuration.patch
@@ -0,0 +1,150 @@
+--- a/modules/admin-full/luasrc/model/cbi/admin_network/wifi.lua
++++ b/modules/admin-full/luasrc/model/cbi/admin_network/wifi.lua
+@@ -1,6 +1,9 @@
+ --[[
+ LuCI - Lua Configuration Interface
+ 
++Copyright (c) 2013 Qualcomm Atheros, Inc.
++Not a Contribution.
++
+ Copyright 2008 Steven Barth <steven@midlink.org>
+ 
+ Licensed under the Apache License, Version 2.0 (the "License");
+@@ -250,6 +253,54 @@ if hwtype == "mac80211" then
+ end
+ 
+ 
++------------------- qcawifi Device ------------------
++
++if hwtype == "qcawifi" then
++	if #tx_power_list > 1 then
++		tp = s:taboption("general", ListValue,
++			"txpower", translate("Transmit Power"), "dBm")
++		tp.rmempty = true
++		tp.default = tx_power_cur
++		function tp.cfgvalue(...)
++			return txpower_current(Value.cfgvalue(...), tx_power_list)
++		end
++
++		for _, p in ipairs(tx_power_list) do
++			tp:value(p.driver_dbm, "%i dBm (%i mW)"
++				%{ p.display_dbm, p.display_mw })
++		end
++	end
++
++
++	mode = s:taboption("advanced", ListValue, "hwmode", translate("Mode"))
++	mode:value("", translate("auto"))
++	if hw_modes.b then mode:value("11b", "802.11b") end
++	if hw_modes.g then mode:value("11g", "802.11g") end
++	if hw_modes.a then mode:value("11a", "802.11a") end
++
++	if hw_modes.g and hw_modes.n then mode:value("11ng", "802.11g+n") end
++	if hw_modes.a and hw_modes.n then mode:value("11na", "802.11a+n") end
++	if hw_modes.ac then mode:value("11ac", "802.11ac") end
++
++	htmode = s:taboption("advanced", ListValue, "htmode", translate("HT mode"))
++	htmode:depends("hwmode", "11na")
++	htmode:depends("hwmode", "11ng")
++	htmode:depends("hwmode", "11ac")
++	htmode:value("HT20", "20MHz")
++	htmode:value("HT40-", translate("40MHz 2nd channel below"))
++	htmode:value("HT40+", translate("40MHz 2nd channel above"))
++	htmode:value("HT80", "80MHz")
++
++
++	s:taboption("advanced", Value, "txantenna", translate("Tx Antenna bitmask"))
++	s:taboption("advanced", Value, "rxantenna", translate("Rx Antenna bitmask"))
++	s:taboption("advanced", Value, "regdomain", translate("Regulatory Domain"))
++	s:taboption("advanced", Value, "country", translate("Country Code"))
++
++end
++
++
++
+ ------------------- Madwifi Device ------------------
+ 
+ if hwtype == "atheros" then
+@@ -506,6 +557,64 @@ if hwtype == "mac80211" then
+ end
+ 
+ 
++-------------------- qcawifi Interface ----------------------
++if hwtype == "qcawifi" then
++	mode:value("ap-wds", "%s (%s)" % {translate("Access Point"), translate("WDS")})
++	mode:value("sta-wds", "%s (%s)" % {translate("Client"), translate("WDS")})
++	mode:value("wds", translate("Static WDS"))
++
++	function mode.write(self, section, value)
++		if value == "ap-wds" then
++			ListValue.write(self, section, "ap")
++			m.uci:set("wireless", section, "wds", 1)
++		elseif value == "sta-wds" then
++			ListValue.write(self, section, "sta")
++			m.uci:set("wireless", section, "wds", 1)
++		else
++			ListValue.write(self, section, value)
++			m.uci:delete("wireless", section, "wds")
++		end
++	end
++
++	function mode.cfgvalue(self, section)
++		local mode = ListValue.cfgvalue(self, section)
++		local wds  = m.uci:get("wireless", section, "wds") == "1"
++
++		if mode == "ap" and wds then
++			return "ap-wds"
++		elseif mode == "sta" and wds then
++			return "sta-wds"
++		else
++			return mode
++		end
++	end
++
++	bssid:depends({mode="wds"})
++
++	s:taboption("advanced", Flag, "doth", "802.11h")
++	hidden = s:taboption("general", Flag, "hidden", translate("Hide <abbr title=\"Extended Service Set Identifier\">ESSID</abbr>"))
++	hidden:depends({mode="ap"})
++	hidden:depends({mode="ap-wds"})
++	hidden:depends({mode="sta-wds"})
++	isolate = s:taboption("advanced", Flag, "isolate", translate("Separate Clients"),
++	 translate("Prevents client-to-client communication"))
++	isolate:depends({mode="ap"})
++	s:taboption("advanced", Flag, "uapsd", translate("UAPSD Enable"))
++	s:taboption("advanced", Value, "mcast_rate", translate("Multicast Rate"))
++	s:taboption("advanced", Value, "frag", translate("Fragmentation Threshold"))
++	s:taboption("advanced", Value, "rts", translate("RTS/CTS Threshold"))
++	s:taboption("advanced", Flag, "wmm", translate("WMM Mode"))
++
++        -------------------------------support 11ac------------------------------
++	if hw_modes.ac then
++		s:taboption("advanced", Value, "nss", translate("Number of Spatial Streams"))
++		s:taboption("advanced", Flag, "ldpc",translate("LDPC"))
++		s:taboption("advanced", Flag,"rx_stbc",translate("RX STBC"))
++		s:taboption("advanced", Flag,"tx_stbc",translate("TX STBC"))
++	end
++
++end
++
+ 
+ -------------------- Madwifi Interface ----------------------
+ 
+@@ -720,7 +829,7 @@ encr:value("none", "No Encryption")
+ encr:value("wep-open",   translate("WEP Open System"), {mode="ap"}, {mode="sta"}, {mode="ap-wds"}, {mode="sta-wds"}, {mode="adhoc"}, {mode="ahdemo"}, {mode="wds"})
+ encr:value("wep-shared", translate("WEP Shared Key"),  {mode="ap"}, {mode="sta"}, {mode="ap-wds"}, {mode="sta-wds"}, {mode="adhoc"}, {mode="ahdemo"}, {mode="wds"})
+ 
+-if hwtype == "atheros" or hwtype == "mac80211" or hwtype == "prism2" then
++if hwtype == "atheros" or hwtype == "qcawifi" or hwtype == "mac80211" or hwtype == "prism2" then
+ 	local supplicant = fs.access("/usr/sbin/wpa_supplicant")
+ 	local hostapd = fs.access("/usr/sbin/hostapd")
+ 
+@@ -881,7 +990,7 @@ for slot=1,4 do
+ end
+ 
+ 
+-if hwtype == "atheros" or hwtype == "mac80211" or hwtype == "prism2" then
++if hwtype == "atheros" or hwtype == "qcawifi" or hwtype == "mac80211" or hwtype == "prism2" then
+ 	nasid = s:taboption("encryption", Value, "nasid", translate("NAS ID"))
+ 	nasid:depends({mode="ap", encryption="wpa"})
+ 	nasid:depends({mode="ap", encryption="wpa2"})
diff --git a/luci/patches/002-miniupnpd.patch b/luci/patches/002-miniupnpd.patch
new file mode 100644
index 0000000..6638e48
--- /dev/null
+++ b/luci/patches/002-miniupnpd.patch
@@ -0,0 +1,56 @@
+--- a/applications/luci-upnp/luasrc/model/cbi/upnp/upnp.lua
++++ b/applications/luci-upnp/luasrc/model/cbi/upnp/upnp.lua
+@@ -4,6 +4,9 @@ LuCI - Lua Configuration Interface
+ Copyright 2008 Steven Barth <steven@midlink.org>
+ Copyright 2008-2011 Jo-Philipp Wich <xm@subsignal.org>
+ 
++Copyright (c) 2013 Qualcomm Atheros, Inc.
++Not a Contribution.
++
+ Licensed under the Apache License, Version 2.0 (the "License");
+ you may not use this file except in compliance with the License.
+ You may obtain a copy of the License at
+@@ -40,14 +43,22 @@ function e.write(self, section, value)
+ 	end
+ end
+ 
+-s:taboption("general", Flag, "enable_upnp", translate("Enable UPnP functionality")).default = "1"
+-s:taboption("general", Flag, "enable_natpmp", translate("Enable NAT-PMP functionality")).default = "1"
+-
+-s:taboption("general", Flag, "secure_mode", translate("Enable secure mode"),
+-	translate("Allow adding forwards only to requesting ip addresses")).default = "1"
++ni = s:taboption("general", Flag, "enable_upnp", translate("Enable UPnP functionality"))
++ni.default = "1"
++ni.rmempty = false
++
++ni = s:taboption("general", Flag, "enable_natpmp", translate("Enable NAT-PMP functionality"))
++ni.default = "1"
++ni.rmempty = false
++
++ni = s:taboption("general", Flag, "secure_mode", translate("Enable secure mode"),
++	translate("Allow adding forwards only to requesting ip addresses"))
++ni.default = "1"
++ni.rmempty = false
+ 
+-s:taboption("general", Flag, "log_output", translate("Enable additional logging"),
++ni = s:taboption("general", Flag, "log_output", translate("Enable additional logging"),
+ 	translate("Puts extra debugging information into the system log"))
++ni.rmempty = false
+ 
+ s:taboption("general", Value, "download", translate("Downlink"),
+ 	translate("Value in KByte/s, informational only")).rmempty = true
+--- a/applications/luci-upnp/root/etc/uci-defaults/luci-upnp
++++ b/applications/luci-upnp/root/etc/uci-defaults/luci-upnp
+@@ -1,9 +1,8 @@
+ #!/bin/sh
++# Copyright (c) 2013 Qualcomm Atheros, Inc.
++# Not a Contribution.
+ 
+-/etc/init.d/miniupnpd enabled && {
+-	/etc/init.d/miniupnpd stop
+-	/etc/init.d/miniupnpd disable
+-}
++/etc/init.d/miniupnpd enabled
+ 
+ rm -f /tmp/luci-indexcache
+ exit 0
diff --git a/luci/patches/003-l2tp.patch b/luci/patches/003-l2tp.patch
new file mode 100644
index 0000000..2c74781
--- /dev/null
+++ b/luci/patches/003-l2tp.patch
@@ -0,0 +1,58 @@
+--- a/protocols/ppp/luasrc/model/cbi/admin_network/proto_l2tp.lua
++++ b/protocols/ppp/luasrc/model/cbi/admin_network/proto_l2tp.lua
+@@ -67,3 +67,55 @@
+ mtu = section:taboption("advanced", Value, "mtu", translate("Override MTU"))
+ mtu.placeholder = "1500"
+ mtu.datatype    = "max(1500)"
++
++keepalive_failure = section:taboption("advanced", Value, "_keepalive_failure",
++	translate("LCP echo failure threshold"),
++	translate("Presume peer to be dead after given amount of LCP echo failures, use 0 to ignore failures"))
++
++function keepalive_failure.cfgvalue(self, section)
++	local v = m:get(section, "keepalive")
++	if v and #v > 0 then
++		return tonumber(v:match("^(%d+)[ ,]+%d+") or v)
++	end
++end
++
++function keepalive_failure.write() end
++function keepalive_failure.remove() end
++
++keepalive_failure.placeholder = "0"
++keepalive_failure.datatype    = "uinteger"
++
++
++keepalive_interval = section:taboption("advanced", Value, "_keepalive_interval",
++	translate("LCP echo interval"),
++	translate("Send LCP echo requests at the given interval in seconds, only effective in conjunction with failure threshold"))
++
++function keepalive_interval.cfgvalue(self, section)
++	local v = m:get(section, "keepalive")
++	if v and #v > 0 then
++		return tonumber(v:match("^%d+[ ,]+(%d+)"))
++	end
++end
++
++function keepalive_interval.write(self, section, value)
++	local f = tonumber(keepalive_failure:formvalue(section)) or 0
++	local i = tonumber(value) or 5
++	if i < 1 then i = 1 end
++	if f > 0 then
++		m:set(section, "keepalive", "%d %d" %{ f, i })
++	else
++		m:del(section, "keepalive")
++	end
++end
++
++keepalive_interval.remove      = keepalive_interval.write
++keepalive_interval.placeholder = "5"
++keepalive_interval.datatype    = "min(1)"
++
++
++encap = section:taboption("advanced", ListValue, "encap", translate("L2TPv3 enacapsulation mode"))
++encap:value("udp",translate("UDP"));
++encap:value("ip",translate("IP"));
++
++pppd_options = section:taboption("advanced",DynamicList, "pppd_options", translate("Additonal command line arguments for PPP"))
++
